#	Masrv
#	Copyright (C) 2007 Michal Vaner (vorner@ucw.cz)
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	he Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import glob
from commandable import commandable

class hooks( commandable ):
	def __init__( self, source, modeler ):
		commandable.__init__( self, { "timestamp":self.__genTimestamps, "position":self.__position } )
		glob.info( "Creating hook handler" )
		self.__source = source
		self.__timehooks = []
		self.__modeler = modeler
		glob.hooks = self

	def tick( self, timestamp ):
		for hook in self.__timehooks:
			( id, stamp ) = hook;
			if timestamp >= stamp:
				self.__timehooks.remove( hook )
				self.trigger( id )

	def __genTimestamps( self, args, id ):
		timestamp = int( args[ 0 ] )
		self.__timehooks.append( ( id, timestamp ) )
		glob.info( "Inserting " + id + ":" + str( timestamp ) )

	def trigger( self, id ):
		self.__source.send( "E[" + id + "]:\n" )

	def __position( self, args, id ):
		( where, what ) = args[ :2 ]
		( x, y ) = map( float, args[ 2:4 ] )
		def convert( x ):
			if x == ">=":
				return 1
			elif x == "<=":
				return -1
			else:
				return 0
		( hix, hiy ) = map( convert, args[ 4:6 ] )
		self.__modeler.posHook( where, what, x, y, hix, hiy, id )
